package com.jasamedika.medifirst2000.controller;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DiagnosaKeperawatanService;
import com.jasamedika.medifirst2000.service.DiagnosaKeperawatanTransaksiService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.DiagnosaKeperawatanTransaksiVO;

@RestController
@RequestMapping("/diagnosa-keperawatan")
public class DiagnosaKeperawatanTransaksiController extends LocaleController {
	
	@Autowired
	private DiagnosaKeperawatanTransaksiService service;
	
	@Autowired
	private DiagnosaKeperawatanService diagnosaKeperawatanService;
	
	private static final Logger LOGGER = LoggerFactory.getLogger(DiagnosaKeperawatanTransaksiController.class);
	
	@RequestMapping(value = "/save-diagnosa-keperawatan", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> saveDiagnosaKeperawatanTransaksi(@Valid @RequestBody List<DiagnosaKeperawatanTransaksiVO> vo, HttpServletRequest request) {
		try {
			Map<String,Object> result = service.saveDiagnosaKeperawatan(vo);
			if (null != result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request));
				return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when saveRencana", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when saveRencana", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}
	
	@RequestMapping(value = "/get-all-master")
	@ResponseBody
	public List<Map<String, Object>> getDiagnosaKeperawatan() {
		return diagnosaKeperawatanService.getDiagnosaKeperawatan();
	}
	
	@RequestMapping(value = "/get-detail-by-master")
	@ResponseBody
	public List<Map<String, Object>> getDetailDiagnosaKeperawatan(
			@RequestParam(value = "id", required = false) Integer id) {
		return diagnosaKeperawatanService.getDetailDiagnosisKeperawatan(id);
	}
	
	@RequestMapping(value = "/get-detail-by-transaction")
	@ResponseBody
	public Map<String, Object> getDetailDiagnosaKeperawatanTransaction(
			@RequestParam(value = "noRec", required = false) String noRec) {
		return diagnosaKeperawatanService.getDetailDiagnosaKeperawatanTransaction(noRec);
	}

}
